import { InjectionToken, Inject, Injectable, Pipe, NgModule } from '@angular/core';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,uselessCode} checked by tsc
 */
/** @type {?} */
const NAMESPACE_NAME = new InjectionToken('NAMESPACE_NAME');
/** @type {?} */
const SEPARATOR_NAME = new InjectionToken('SEPARATOR_NAME');

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,uselessCode} checked by tsc
 */
class SelectorOptionalsModel {
    /**
     * @param {?} id
     * @param {?} name
     */
    constructor(id, name) {
        this.id = id;
        this.name = name;
    }
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,uselessCode} checked by tsc
 */
class EnumsPipe {
    /**
     * @param {?} nameSpaceGlobal
     * @param {?} separatorGlobal
     */
    constructor(nameSpaceGlobal, separatorGlobal) {
        this.nameSpaceGlobal = nameSpaceGlobal;
        this.separatorGlobal = separatorGlobal;
    }
    /**
     * @param {?} currentEnum
     * @param {?} __1
     * @return {?}
     */
    transform(currentEnum, { dictName, nameSpace = '', ignored = [] }) {
        /** @type {?} */
        const currentNameSpace = nameSpace ? nameSpace : this.nameSpaceGlobal;
        /** @type {?} */
        const resultArray = [];
        if (currentEnum) {
            Object.keys(currentEnum)
                .filter((x) => Number.isNaN(parseInt(x, 10)))
                .map((key) => {
                if (!(ignored.find((field) => field === key))) {
                    resultArray.push(new SelectorOptionalsModel(currentEnum[key], `${currentNameSpace}${this.separatorGlobal}${dictName}.${key}`));
                }
            });
        }
        return resultArray;
    }
}
EnumsPipe.decorators = [
    { type: Pipe, args: [{
                name: 'enumList'
            },] },
    { type: Injectable }
];
/** @nocollapse */
EnumsPipe.ctorParameters = () => [
    { type: String, decorators: [{ type: Inject, args: [NAMESPACE_NAME,] }] },
    { type: String, decorators: [{ type: Inject, args: [SEPARATOR_NAME,] }] }
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,uselessCode} checked by tsc
 */
class EnumsKeyPipe {
    /**
     * @param {?} nameSpaceGlobal
     * @param {?} separatorGlobal
     */
    constructor(nameSpaceGlobal, separatorGlobal) {
        this.nameSpaceGlobal = nameSpaceGlobal;
        this.separatorGlobal = separatorGlobal;
    }
    /**
     * @param {?} value
     * @param {?} __1
     * @return {?}
     */
    transform(value, { dictName, currentEnum, nameSpace }) {
        /** @type {?} */
        const currentNameSpace = nameSpace ? nameSpace : this.nameSpaceGlobal;
        /** @type {?} */
        let resultKeyPath = '';
        /** @type {?} */
        let key = Object.keys(currentEnum).find(key => currentEnum[key] === value);
        if (currentEnum && key) {
            resultKeyPath = `${currentNameSpace}${this.separatorGlobal}${dictName}.${key}`;
        }
        return resultKeyPath;
    }
}
EnumsKeyPipe.decorators = [
    { type: Pipe, args: [{
                name: 'enumKey'
            },] },
    { type: Injectable }
];
/** @nocollapse */
EnumsKeyPipe.ctorParameters = () => [
    { type: String, decorators: [{ type: Inject, args: [NAMESPACE_NAME,] }] },
    { type: String, decorators: [{ type: Inject, args: [SEPARATOR_NAME,] }] }
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,uselessCode} checked by tsc
 */
class AngularEnumsListModule {
    /**
     * @param {?=} namespace
     * @param {?=} separator
     * @return {?}
     */
    static forRoot(namespace = null, separator = null) {
        return {
            ngModule: AngularEnumsListModule,
            providers: [
                {
                    provide: NAMESPACE_NAME,
                    useValue: namespace || 'enums'
                },
                {
                    provide: SEPARATOR_NAME,
                    useValue: separator || ':'
                }
            ]
        };
    }
}
AngularEnumsListModule.decorators = [
    { type: NgModule, args: [{
                declarations: [
                    EnumsPipe,
                    EnumsKeyPipe
                ],
                exports: [
                    EnumsPipe,
                    EnumsKeyPipe
                ],
                providers: [
                    AngularEnumsListModule,
                    EnumsPipe,
                    EnumsKeyPipe
                ]
            },] }
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,uselessCode} checked by tsc
 */

export { AngularEnumsListModule, EnumsPipe, NAMESPACE_NAME, SEPARATOR_NAME, SelectorOptionalsModel, EnumsKeyPipe };

//# sourceMappingURL=angular-enum-list.js.map