import { InjectionToken, Inject, Injectable, Pipe, NgModule } from '@angular/core';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,uselessCode} checked by tsc
 */
/** @type {?} */
var NAMESPACE_NAME = new InjectionToken('NAMESPACE_NAME');
/** @type {?} */
var SEPARATOR_NAME = new InjectionToken('SEPARATOR_NAME');

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,uselessCode} checked by tsc
 */
var SelectorOptionalsModel = /** @class */ (function () {
    function SelectorOptionalsModel(id, name) {
        this.id = id;
        this.name = name;
    }
    return SelectorOptionalsModel;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,uselessCode} checked by tsc
 */
var EnumsPipe = /** @class */ (function () {
    function EnumsPipe(nameSpaceGlobal, separatorGlobal) {
        this.nameSpaceGlobal = nameSpaceGlobal;
        this.separatorGlobal = separatorGlobal;
    }
    /**
     * @param {?} currentEnum
     * @param {?} __1
     * @return {?}
     */
    EnumsPipe.prototype.transform = /**
     * @param {?} currentEnum
     * @param {?} __1
     * @return {?}
     */
    function (currentEnum, _a) {
        var _this = this;
        var dictName = _a.dictName, _b = _a.nameSpace, nameSpace = _b === void 0 ? '' : _b, _c = _a.ignored, ignored = _c === void 0 ? [] : _c;
        /** @type {?} */
        var currentNameSpace = nameSpace ? nameSpace : this.nameSpaceGlobal;
        /** @type {?} */
        var resultArray = [];
        if (currentEnum) {
            Object.keys(currentEnum)
                .filter(function (x) { return Number.isNaN(parseInt(x, 10)); })
                .map(function (key) {
                if (!(ignored.find(function (field) { return field === key; }))) {
                    resultArray.push(new SelectorOptionalsModel(currentEnum[key], "" + currentNameSpace + _this.separatorGlobal + dictName + "." + key));
                }
            });
        }
        return resultArray;
    };
    EnumsPipe.decorators = [
        { type: Pipe, args: [{
                    name: 'enumList'
                },] },
        { type: Injectable }
    ];
    /** @nocollapse */
    EnumsPipe.ctorParameters = function () { return [
        { type: String, decorators: [{ type: Inject, args: [NAMESPACE_NAME,] }] },
        { type: String, decorators: [{ type: Inject, args: [SEPARATOR_NAME,] }] }
    ]; };
    return EnumsPipe;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,uselessCode} checked by tsc
 */
var EnumsKeyPipe = /** @class */ (function () {
    function EnumsKeyPipe(nameSpaceGlobal, separatorGlobal) {
        this.nameSpaceGlobal = nameSpaceGlobal;
        this.separatorGlobal = separatorGlobal;
    }
    /**
     * @param {?} value
     * @param {?} __1
     * @return {?}
     */
    EnumsKeyPipe.prototype.transform = /**
     * @param {?} value
     * @param {?} __1
     * @return {?}
     */
    function (value, _a) {
        var dictName = _a.dictName, currentEnum = _a.currentEnum, nameSpace = _a.nameSpace;
        /** @type {?} */
        var currentNameSpace = nameSpace ? nameSpace : this.nameSpaceGlobal;
        /** @type {?} */
        var resultKeyPath = '';
        /** @type {?} */
        var key = Object.keys(currentEnum).find(function (key) { return currentEnum[key] === value; });
        if (currentEnum && key) {
            resultKeyPath = "" + currentNameSpace + this.separatorGlobal + dictName + "." + key;
        }
        return resultKeyPath;
    };
    EnumsKeyPipe.decorators = [
        { type: Pipe, args: [{
                    name: 'enumKey'
                },] },
        { type: Injectable }
    ];
    /** @nocollapse */
    EnumsKeyPipe.ctorParameters = function () { return [
        { type: String, decorators: [{ type: Inject, args: [NAMESPACE_NAME,] }] },
        { type: String, decorators: [{ type: Inject, args: [SEPARATOR_NAME,] }] }
    ]; };
    return EnumsKeyPipe;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,uselessCode} checked by tsc
 */
var AngularEnumsListModule = /** @class */ (function () {
    function AngularEnumsListModule() {
    }
    /**
     * @param {?=} namespace
     * @param {?=} separator
     * @return {?}
     */
    AngularEnumsListModule.forRoot = /**
     * @param {?=} namespace
     * @param {?=} separator
     * @return {?}
     */
    function (namespace, separator) {
        if (namespace === void 0) { namespace = null; }
        if (separator === void 0) { separator = null; }
        return {
            ngModule: AngularEnumsListModule,
            providers: [
                {
                    provide: NAMESPACE_NAME,
                    useValue: namespace || 'enums'
                },
                {
                    provide: SEPARATOR_NAME,
                    useValue: separator || ':'
                }
            ]
        };
    };
    AngularEnumsListModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [
                        EnumsPipe,
                        EnumsKeyPipe
                    ],
                    exports: [
                        EnumsPipe,
                        EnumsKeyPipe
                    ],
                    providers: [
                        AngularEnumsListModule,
                        EnumsPipe,
                        EnumsKeyPipe
                    ]
                },] }
    ];
    return AngularEnumsListModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,uselessCode} checked by tsc
 */

export { AngularEnumsListModule, EnumsPipe, NAMESPACE_NAME, SEPARATOR_NAME, SelectorOptionalsModel, EnumsKeyPipe };

//# sourceMappingURL=angular-enum-list.js.map